<template>
    <div>
        <div id="membersArea" v-if="membersList.length > 0" >
            <div
                class="eachMember"
                @click="toggleDetails(mem.fullname, mem.email)"
                v-for="mem in membersList"
                v-bind:data="mem"
                v-bind:key="mem._id"
            >
                <img :src=memberImageUri />
                <div> 
                    <div class="fullname">{{mem.fullname}}</div>
                    <div>{{mem.email}}</div>
                </div>
            </div>
        </div>

            <modal
                name="seeMemberDetails"
                transition="pop-out"
                :width="modalWidth"
                height="auto"
                >
                <div class="boxM">
                    <div class="partitionM">
                        <div class="partitionM-title"> Member's Detail </div>
                        <div class="partitionM-line"></div>
                        <div style="margin-top: 15px"></div>
                        <div class="partitionM-details">
                            <div>Fullname : {{clickedMemberName}} </div>
                            <div>Email : {{clickedMemberMail}} </div>
                        </div>
                    <button id="close-btn" @click="hideModal()">Close</button>
                    </div>
                </div>
            </modal>

    </div>

    


</template>

<script>

    export default {
        name : "Members",
        data(){
            return {
                membersList: [],
                memberImageUri: "",
                modalWidth: 656,
                clickedMemberName : '',
                clickedMemberMail : '',
            }
        },
        mounted () {

            window.axios.get('members').then((response) =>{
                this.membersList = response.data;

                this.membersList.forEach((mem)=>{
                    this.gravatarHash(mem.email)
                })
                
            }).catch((error)=>{
                alert(error.message);

            });
            

        },
        computed : {

        },
        methods : {
            gravatarHash(email){
                var md5 = require('md5');
                this.memberImageUri = "https://www.gravatar.com/avatar/" +md5(email) +".jpg"
                return this.memberImageUri;
            },

            toggleDetails(name, mail){
                this.clickedMemberName = name;
                this.clickedMemberMail = mail;
                this.showModal();
            },

            //modal method
            showModal() {
                this.$modal.show("seeMemberDetails");
            },

            //modal method
            hideModal() {
                this.$modal.hide("seeMemberDetails");
            },
    
        }
    }
</script>

<style lang="scss">

  $lightpurple : rgb(165, 160, 187);

#membersArea{
    margin : 20px auto;
    width : 50%;
    color : $lightpurple;    

    .eachMember{
        background-color: #261F28;
        margin : 20px;
        padding : 20px;
        border-radius: 20px;
        display: flex;
        &:hover{
            cursor : pointer;
        }

        img{
            border-radius: 50%;
            margin-right : 40px;
        }

        .fullname{
            font-weight: bold
        }
    }
    
}


.boxM {
  background: rgb(16, 13, 17);
  overflow: hidden;
  width: 656px;
  height: auto;
  border-radius: 2px;
  box-sizing: border-box;
  box-shadow: 0 0 40px black;
  color: #8b8c8d;
  font-size: 0;

  .partitionM {
    width: 100%;
    height: 100%;
    .partitionM-title {
      box-sizing: border-box;
      padding: 30px;
      width: 100%;
      text-align: center;
      letter-spacing: 1px;
      font-size: 20px;
      font-weight: 300;
    }
    .partitionM-line, {
      box-sizing: border-box;
      padding: 5px;
      width: 100%;
      text-align: center;
      font-size: 15px;
      font-weight: 300;
      background-color: #29272E;
      color: #336699;
    }
    .partitionM-details{
    box-sizing: border-box;
      padding: 30px;
      width: 100%;
      text-align: center;
      letter-spacing: 1px;
      font-size: 17px;
      font-weight: 300;
    }

  }
  button {
    background: #29272E;
    border-radius: 4px;
    box-sizing: border-box;
    padding: 10px;
    letter-spacing: 1px;
    font-family: "Open Sans", sans-serif;
    font-weight: 400;
    min-width: 140px;
    margin: 8px 0 8px 8px;
    color: #8b8c8d;
    cursor: pointer;
    border: 1px solid #29272E;
    text-transform: uppercase;
    transition: 0.1s all;
    font-size: 10px;
    outline: none;
    &:hover {
      border-color: mix(#dddedf, black, 90%);
      color: mix(#dddedf, black, 90%);
      background-color: #29272E;
    }
  }

}

</style>
